from _Framework.DeviceComponent import DeviceComponent
from MrSysex import MrSysex


class MrDeviceComponent(DeviceComponent):

	def __init__(self):
		DeviceComponent.__init__(self)

	def _on_device_name_changed(self):
		self._send_state()

	def _on_parameters_changed(self):
		self.update()

	def update(self):
		DeviceComponent.update(self)
		self._send_state()

	def _send_state(self):
		if self._device != None:
			sysex = MrSysex('CHAIN_NAMES')
			sysex.ascii(self._device.name)
			if 'Group' not in self._device.class_name:
				banks = self._device_banks[self._device.class_name]
				if not self._is_banking_enabled():
					banks = self._device_best_banks[self._device.class_name]
				bank = banks[self._bank_index]
				for param in range(len(self._parameter_controls)):
					sysex.ascii(bank[param])
			else:
				for index in range(8):
					sysex.ascii(self._device.parameters[index+1].name)
			sysex.send()

	def disconnect(self):
		DeviceComponent.disconnect(self)